/* AddAGPath.c */
/* 16 Oct 1993 12:18:33 */

#include <proto/dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define	AGFILENAME	"AmigaGuide/Path"


static void EnlargePathList(void);


char AGPath[1024];
char **PathList;
char *NewPath, *PathPtr;
size_t PathCount = 0, PathMax = 0;
short n;

main(int argc, char *argv[])
{
	if (argc != 2)
		{
		fprintf(stderr, "Usage: AddAGPath <NewPath>\n");
		exit(2);
		}

	NewPath = stpblk(argv[1]);
	if (*NewPath == '"')
		NewPath++;
	if (NewPath[strlen(NewPath)-1] == '"')
		NewPath[strlen(NewPath)-1] = '\0';

	if (GetVar(AGFILENAME, AGPath, sizeof(AGPath), GVF_BINARY_VAR|GVF_GLOBAL_ONLY) > 0)
		{
		PathPtr = stpblk(AGPath);
		while (*PathPtr)
			{
			size_t l, l2;

			if (*PathPtr == '"')
				{
				PathPtr++;	/* '"' am Anfang berspringen */
				for (l=0; PathPtr[l] && PathPtr[l] != '"'; l++);
				l2 = l + 1;
				}
			else
				{
				for (l=0; PathPtr[l] && !isspace(PathPtr[l]); l++);
				l2 = l;
				}

			if (PathCount >= PathMax)
				EnlargePathList();

			PathList[PathCount] = calloc(l+1, 1);
			if (PathList[PathCount] == NULL)
				{
				fprintf(stderr, "out of memory for PathList[%ld]\n", PathCount);
				exit(50);
				}
			strncpy(PathList[PathCount], PathPtr, l);
			PathList[PathCount][l] = '\0';
			PathCount++;

			PathPtr = stpblk(PathPtr + l2);
			}
		}

	for (n=0; n<PathCount; n++)
		{
		if (stricmp(PathList[n], NewPath) == 0)
			exit(0);	/* den neuen Pfad gibt es schon */
		}

	for (n=0, PathPtr=AGPath; n<PathCount; n++)
		{
		sprintf(PathPtr, "\"%s\"\n", PathList[n]);
		PathPtr += strlen(PathPtr);
		}

	sprintf(PathPtr, "\"%s\"\n", NewPath);

	SetVar(AGFILENAME, AGPath, strlen(AGPath), GVF_GLOBAL_ONLY);
}


static void EnlargePathList(void)
{
	PathMax += 20;

	if (PathList)
		PathList = realloc(PathList, PathMax * sizeof(char *));
	else
		PathList = calloc(PathMax, sizeof(char *));
	if (PathList == NULL)
		{
		fprintf(stderr, "out of memory for PathList\n");
		exit(50);
		}
}
